const markers = {}
const info = wx.getSystemInfoSync()
const centerControl = {
  id: 0,
  iconPath: '/resources/mine.png',
  position: {
    top: (300) / 2 - 40,
    left: (info.windowWidth - 30 - 40) / 2,
    width: 40,
    height: 40
  },
  clickable: false
};

const tipsControl = {
  id: 3,
  iconPath: '/resources/dialog.png',
  position: {
    top: (300) / 2 - 40 - 64,
    left: (info.windowWidth - 30 - 105) / 2,
    width: 85,
    height: 64
  },
  clickable: true
}

const locationControl = {
  id: 1,
  iconPath: '/resources/location.png',
  position: {
    left: 0,
    top: 300 - 50,
    width: 50,
    height: 51
  },
  clickable: true
};

const reloadControl = {
  id: 2,
  iconPath: '/resources/reload.png',
  position: {
    left: 8,
    top: 300 - 50 - 34,
    width: 34, 
    height: 34
  },
  clickable: true
};

Page({
  data: {
    ready: false,
    latitude: 23.099994,
    longitude: 113.324520,
    // markers: [{
    //   latitude: 23.099994,
    //   longitude: 113.324520,
    //   name: 'T.I.T 创意园',
    //   desc: '我现在的位置'
    // }],
    // markers: [{
    //   iconPath: "/resources/others.png",
    //   latitude: 23.099994,
    //   longitude: 113.324520,
    //   width: 50,
    //   height: 50,
    //   rotate: 90,
    //   title: 'x'
    // }],
    // markers: [],
    controls: [],
    // polyline: [],
    polyline: [{
      points: [{
        longitude: 113.3345211,
        latitude: 23.10229
      }, {
        longitude: 113.334520,
        latitude: 23.21229
      }],
      color:"#69de7d",
      width: 20,
      arrowLine: true,
      arrowIconPath: '/resources/others.png',
      borderColor: '#000000',
      borderWidth: 1,
    }],
    // points: [{
    //   latitude:23.10229,
    //   longitude:113.3245211,
    //   title:"广州市广东省广州市越秀区广卫街道广州市广大路37号",
    // }, {
    //   latitude:23.10229,
    //   longitude:114.3245211,
    //   title:"广州市广东省广州市越秀区广卫街道广州市广大路37号",
    // }]
    markers: [{
      id: 0,
      height: 50,
      latitude:23.10229,
      longitude:113.3245211,
      // title:"广州市广东省广州市越秀区广卫街道广州市广大路37号",
      width: 100,
      iconPath: "/resources/car.jpg",
      callout: {
        content: '在这里上车',
        // color: '#333333',
        // fontSize: 14,
        // borderRadius: 18,
        bgColor: '#FFFFFF',
        // padding: 10,
        // display: 'ALWAYS',
        // boxShadow: '3 0 #000000AA',
        // shadowColor: '#000000AA',
        // shadowOffsetX: 0,
        // shadowOffsetY: 3,
        // borderColor: '#000000',
        // borderWidth: 10,
      },
      // label: {
      //   content: 'T.I.T\n创意园',
      //   color: '#333333',
      //   fontSize: 14,
      //   x: 20,
      //   y: 0,
      // }
    }, {
      latitude:23.10229,
      longitude:113.3245211,
    }]
  },
  onLoad() {
    this.map = wx.createMapContext('map')
    this.shouldGetCenter = true
    this.lastCenter = {}

    wx.getLocation({
      success: (res) => {
        console.log('getLocation', res)
        this.setData({
          longitude: res.longitude,
          latitude: res.latitude
        })
      }
    })


    this.setData({
      controls: [centerControl, locationControl, reloadControl, tipsControl],
      points: [{
        latitude:23.10229,
        longitude:113.4245211,
      }, {
        latitude:23.10229,
        longitude:113.3245211,
      }]
    })

    setTimeout(() => {
      console.log('translateMarker', Date.now())
      this.map.translateMarker({
        markerId: 0,
        destination: {
          latitude:23.10229,
          longitude:113.3345211,
        },
        autoRotate: true,
        duration: 1000,
        animationEnd() {
          console.log('animationEnd', Date.now())
        },

        // keyFrames: [{
        //   longitude: 113.3245211,
        //   latitude: 23.11229,
        //   duration: 1000
        // }, {
        //   longitude: 113.3245211,
        //   latitude: 23.10229,
        //   duration: 1000,
        // }, {
        //   rotate: 90,
        //   duration: 1000
        // }],
        // success(res) {
        //   console.log('translateMarker', res)
        // }
      })

      setTimeout(() => {
        this.map.translateMarker({
          markerId: 0,
          autoRotate: true,
          destination: {
            latitude:23.10229,
            longitude:113.3395211,
          }
        });

        setTimeout(() => {
          this.map.translateMarker({
            markerId: 0,
            autoRotate: true,
            destination: {
              latitude:23.11229,
              longitude:113.3445211,
            }
          });
        }, 500)
      }, 500)
    }, 3000)

      
  },
  tap() {
    console.log('tap')
    // return;
    if (!this.shouldGetCenter) {
      this.data.longitude = 0;
      this.data.latitude = 0;
      this.setData({
        polyline: [],
        controls: [centerControl, locationControl, reloadControl, tipsControl],
        markers: this._mks,
        // points: [this.lastCenter]
        longitude: this.lastCenter.longitude,
        latitude: this.lastCenter.latitude
      })
      this.clickReload = true
    }
  },
  callouttap(e) {
    console.log('callout', e)
  },
  controlclick(e) {
    console.log('tap control')
    if (e.controlId === 1) {
      this.map.moveToLocation()
      this.setData({
        polyline: [],
        controls: [centerControl, locationControl, reloadControl, tipsControl],
        markers: this._mks
      })
      this.shouldGetCenter = true
    }

    if (e.controlId === 2) {
      this.data.longitude = 0;
      this.data.latitude = 0;
      this.setData({
        polyline: [],
        controls: [centerControl, locationControl, reloadControl, tipsControl],
        markers: this._mks,
        points: [this.lastCenter]
        // longitude: this.lastCenter.longitude,
        // latitude: this.lastCenter.latitude
      })
      this.clickReload = true
    }
  },
  markerclick(e) {
    console.log('markerclick')
    // return
    this.shouldGetCenter = false
    const marker = markers[e.markerId]
    if (marker) {
      this.setData({
        polyline: [{
          points: [this.lastCenter, {
            longitude: marker.longitude,
            latitude: marker.latitude
          }],
          color:"#339ACECC",
          width: 5,
          dottedLine: false
        }],
        markers: this._mks.concat([{
          latitude: this.lastCenter.latitude,
          longitude: this.lastCenter.longitude,
          iconPath: '/resources/mine.png',
          width: 40,
          height: 40
        }]),
        controls: [locationControl, reloadControl]
      })
    }
  },
  regionchange(e) {
    console.log('regionchange', e)
    // return
    if (this.shouldGetCenter) {
      const controls = []
      this.data.controls.forEach(c => {
        if (c.id !== tipsControl.id) {
          controls.push(c)
        }
      })

      if (e.type === 'begin') {
        this.setData({
          controls: controls
        })
      } else {
        this.setData({
          controls: controls.concat([tipsControl])
        })
      }
    }

    if (e.type === 'end' && this.shouldGetCenter) {
      this.map.getCenterLocation({
        success: (res) => {
          console.log(res)
          this.generateRandomPoints(res)
          this.lastCenter = {
            longitude: res.longitude,
            latitude: res.latitude
          }
        }
      })
    }

    if (e.type === 'end' && this.clickReload) {
      this.clickReload = false
      this.shouldGetCenter = true
    }

    if (e.type === 'end' && this.includePoints) {
      this.includePoints = false
      this.shouldGetCenter = true
    }
  },
  generateRandomPoints(point) {
    const lastCenter = this.lastCenter
    if (lastCenter.longitude === point.longitude && lastCenter.latitude === point.latitude) {
      return
    }

    const points = []
    let count = Math.random() * 10 | 0

    while (count --) {
      points.push({
        latitude: (point.latitude + Math.random() / 100 * (Math.random() > .5 ? 1 : -1)).toFixed(5) * 1,
        longitude: (point.longitude + Math.random() / 100 * (Math.random() > .5 ? 1 : -1)).toFixed(5) * 1
      })
    }

    const mks = points.map((p, i) => {
      const m = {
        id: i,
        latitude: p.latitude,
        longitude: p.longitude,
        iconPath: '/resources/others.png',
        width: 40,
        height: 40
      }

      markers[i] = m

      return m
    })

    this._mks = mks;
    // this.data.longitude = point.longitude;
    // this.data.latitude = point.latitude;
    this.setData({
      markers: mks
    })
    // this.includePoints = true
    // this.shouldGetCenter = false
  },
  invoke() {
    wx.invoke('moveMapCovers',{},function(res){
      console.log(res)
    });
  }
})
